<?php
namespace Teknisa\CNC\Controllers;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request;
use Teknisa\CNC\Services;
use Teknisa\CNC\Utilities;

class Cnc00700RecebimentoBandeira extends \Zeedhi\Framework\Controller\Simple {
    
    protected $entityManager;
    protected $bandeiraService;
    protected $salesMessage;
    
    public function __construct(\Doctrine\ORM\EntityManager $entityManager, Services\Cnc00700RecebimentoBandeira $bandeiraService, Utilities\SalesMessageCNC $salesMessage) {
        $this->entityManager   = $entityManager;
        $this->bandeiraService = $bandeiraService;
        $this->salesMessage    = $salesMessage;
    }

    public function getReceiptFlags(Request\Filter $request, Response $response){
        try {
            $params = $request->getFilterCriteria()->getConditions();
            for ($i=0; $i < sizeof($params); $i++) {
                if($params[$i]["columnName"] === 'condicaoRecebimento'){
                    $MEIORECE = str_replace('%', '', $params[$i]['value']);
                }
            }

            if($MEIORECE === "P"){
                $resultado = $this->bandeiraService->getReceiptFlagsP($params);
            } else{
                $resultado = $this->bandeiraService->getReceiptFlagsR($params);
            }
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('Cnc00700_GetRecebimentosBandeira', $resultado));

        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }

    public function getReceiptFlagsDetails(Request\Filter $request, Response $response){
        try {
            $params = $request->getFilterCriteria()->getConditions();
            $resultadoFiltrado = $this->bandeiraService->getReceiptFlagsDetails($params, $request);

            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('Cnc00700_GetRecebimentosBandeiraDetalhes', $resultadoFiltrado));
        } catch (\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }
    }
}