<?php
namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class Cnc00800CompVendasFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function getValoresVendas ($params) {
        /* O select abaixo não pôde pegar como base a tabela CONSMOVCAIXA porque se usarmos a tabela estaremos
           fazendo que o select retorne somente vendas que foram conciliadas */
        $sql = "SELECT DATAVENDA, ORDEM, VRPAGOVENDA, VRVENDAPREVISTA, TOTALGERALPREV, TOTALGERALPAGO, TOTALGERALPAGO - TOTALGERALPREV DIF
                  FROM
                    (SELECT DATAVENDA, ORDEM, VRPAGOVENDA, VRVENDAPREVISTA, SUM(VRVENDAPREVISTA) OVER (PARTITION BY OI) TOTALGERALPREV,
                            SUM(VRPAGOVENDA) OVER (PARTITION BY OI) TOTALGERALPAGO
                       FROM (SELECT DATAVENDA, ORDEM, VRPAGOVENDA, VRVENDAPREVISTA, OI
                               FROM (SELECT PAGO.DATAVENDA, PAGO.ORDEM, SUM(VRPAGOVENDA) VRPAGOVENDA, SUM(VRVENDAPREVISTA) VRVENDAPREVISTA, PAGO.OI
                                   FROM (SELECT DECODE(:TIPODATA, 'M', REPLACE(TO_CHAR(R.DTVENDA, 'MONTH-YYYY'), ' ', ''), REPLACE(TO_CHAR(R.DTVENDA, 'DD/MM/YY'), ' ', '')) DATAVENDA,
                                                TO_NUMBER(TO_CHAR(R.DTVENDA, 'YYYYMM')) ORDEM, SUM(VRLIQPGTO) VRPAGOVENDA, R.NRPARCELA, R.CDNSU, R.DTVENDA, R.NRAUTORIZACAO,
                                                R.NRESTABELEC, 'X' OI
                                           FROM RETFINANCADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B, ESTABELECIMENTO E
                                          WHERE R.NRADQUIRENTE = A.NRADQUIRENTE
                                            AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                                            AND E.NRESTABELEC = R.NRESTABELEC
                                            AND R.DTVENDA BETWEEN TO_DATE(:DTVENDAINI, 'DD/MM/YYYY') AND TO_DATE(:DTVENDAFIN, 'DD/MM/YYYY')
                                            AND ((INSTR (:NRESTABELEC, E.NRESTABELEC) > 0) OR ('T' = :TNRESTABELEC))
                                            AND ((INSTR (:NRADQUIRENTE, '|'||A.NRADQUIRENTE||'|') > 0) OR ('T' = :TNRADQUIRENTE))
                                            AND ((INSTR (:NRPRODUTOADQ, '|'||P.NRPRODUTOADQ||'|') > 0) OR ('T' = :TNRPRODUTOADQ))
                                            AND ((INSTR (:NRBANDEIRAVAN, '|'||B.NRBANDEIRAVAN||'|') > 0) OR ('T' = :TNRBANDEIRAVAN))
                                          GROUP BY DECODE(:TIPODATA, 'M', REPLACE(TO_CHAR(R.DTVENDA, 'MONTH-YYYY'), ' ', ''), REPLACE(TO_CHAR(R.DTVENDA, 'DD/MM/YY'), ' ', '')),
                                                   TO_NUMBER(TO_CHAR(R.DTVENDA, 'YYYYMM')), R.NRPARCELA, R.CDNSU, R.DTVENDA, R.NRAUTORIZACAO, R.NRESTABELEC) PAGO,
                
                                        (SELECT DECODE(:TIPODATA, 'M', REPLACE(TO_CHAR(R.DTVENDA, 'MONTH-YYYY'), ' ', ''), REPLACE(TO_CHAR(R.DTVENDA, 'DD/MM/YY'), ' ', '')) DATAVENDA,
                                                TO_NUMBER(TO_CHAR(R.DTVENDA, 'YYYYMM')) ORDEM, SUM(VRLIQVENDA) VRVENDAPREVISTA, R.NRPARCELA, R.CDNSU, R.DTVENDA, R.NRAUTORIZACAO,
                                                R.NRESTABELEC, 'X' OI
                                           FROM RETVENDAADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B, ESTABELECIMENTO E
                                          WHERE R.NRADQUIRENTE = A.NRADQUIRENTE
                                            AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                                            AND E.NRESTABELEC = R.NRESTABELEC
                                            AND R.DTVENDA BETWEEN TO_DATE(:DTVENDAINI, 'DD/MM/YYYY') AND TO_DATE(:DTVENDAFIN, 'DD/MM/YYYY')
                                            AND ((INSTR (:NRESTABELEC, E.NRESTABELEC) > 0) OR ('T' = :TNRESTABELEC))
                                            AND ((INSTR (:NRADQUIRENTE, A.NRADQUIRENTE) <> 0)   OR ('T' = :TNRADQUIRENTE))
                                            AND ((INSTR (:NRPRODUTOADQ, P.NRPRODUTOADQ) <> 0)   OR ('T' = :TNRPRODUTOADQ))
                                            AND ((INSTR (:NRBANDEIRAVAN, B.NRBANDEIRAVAN) <> 0) OR ('T' = :TNRBANDEIRAVAN))
                                         GROUP BY DECODE(:TIPODATA, 'M', REPLACE(TO_CHAR(R.DTVENDA, 'MONTH-YYYY'), ' ', ''), REPLACE(TO_CHAR(R.DTVENDA, 'DD/MM/YY'), ' ', '')),
                                                   TO_NUMBER(TO_CHAR(R.DTVENDA, 'YYYYMM')), R.NRPARCELA, R.CDNSU, R.DTVENDA, R.NRAUTORIZACAO, R.NRESTABELEC) PREV
                                    WHERE PAGO.NRPARCELA = PREV.NRPARCELA
                                     AND PAGO.CDNSU = PREV.CDNSU
                                     AND PAGO.DTVENDA = PREV.DTVENDA
                                     AND PAGO.NRAUTORIZACAO = PREV.NRAUTORIZACAO
                                     AND PAGO.NRESTABELEC = PREV.NRESTABELEC
                                    GROUP BY PAGO.DATAVENDA, PAGO.ORDEM, PAGO.OI)))
                                    ORDER BY 2, 1
                ";
                
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getValoresVendasDetails ($params) {
        $sql = "SELECT PAGO.DTVENDA, PAGO.DTORDENACAO, VRLIQPGTO VRRECEBIDO, VRLIQVENDA VRESPERADO, PREV.CDNSU, PAGO.NMESTABELEC, PAGO.NRADQUIRENTE, PAGO.NMADQUIRENTE, PAGO.NRPRODUTOADQ, PAGO.NMPRODUTOADQ, PAGO.NRBANDEIRAVAN, PAGO.NMBANDEIRA
                   FROM (SELECT TO_CHAR(R.DTVENDA, 'DD/MM/YY') DTVENDA, R.DTVENDA DTORDENACAO, VRLIQPGTO, R.NRPARCELA, R.CDNSU, R.NRAUTORIZACAO,
                                R.NRESTABELEC, R.NRADQUIRENTE, E.NMESTABELEC, A.NMADQUIRENTE, R.NRPRODUTOADQ, P.NMPRODUTOADQ, R.NRBANDEIRAVAN, B.NMBANDEIRA
                           FROM RETFINANCADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B, ESTABELECIMENTO E
                          WHERE R.NRADQUIRENTE = A.NRADQUIRENTE
                            AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN
                            AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                            AND E.NRESTABELEC = R.NRESTABELEC
                            AND R.DTVENDA BETWEEN TO_DATE(:DTVENDAINI, 'DD/MM/YYYY') AND TO_DATE(:DTVENDAFIN, 'DD/MM/YYYY')
                            AND ((INSTR (:NRESTABELEC, E.NRESTABELEC) <> 0) OR ('T' = :TNRESTABELEC))
                            AND ((INSTR (:NRADQUIRENTE, A.NRADQUIRENTE) <> 0) OR ('T' = :TNRADQUIRENTE))
                            AND ((INSTR (:NRPRODUTOADQ, P.NRPRODUTOADQ) <> 0) OR ('T' = :TNRPRODUTOADQ))
                            AND ((INSTR (:NRBANDEIRAVAN, B.NRBANDEIRAVAN) <> 0) OR ('T' = :TNRBANDEIRAVAN))
                            AND ((INSTR (   R.DTVENDA || '_' || 
                                            E.NMESTABELEC || '_' || 
                                            A.NMADQUIRENTE || '_' || 
                                            R.CDNSU, :ALL_FIELDS) <> 0) OR ('T' = :TALL_FIELDS))
                        ) PAGO,
                        (SELECT TO_CHAR(R.DTVENDA, 'DD/MM/YY') DTVENDA, R.DTVENDA DTORDENACAO ,VRLIQVENDA, R.NRPARCELA, R.CDNSU, R.NRAUTORIZACAO,
                                R.NRESTABELEC, R.NRADQUIRENTE, A.NMADQUIRENTE, R.NRPRODUTOADQ, P.NMPRODUTOADQ, R.NRBANDEIRAVAN, B.NMBANDEIRA
                           FROM RETVENDAADQ R, ADQUIRENTE A, PRODUTOADQ P, BANDEIRAVAN B, ESTABELECIMENTO E
                          WHERE R.NRADQUIRENTE = A.NRADQUIRENTE
                            AND R.NRBANDEIRAVAN = B.NRBANDEIRAVAN
                            AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                            AND E.NRESTABELEC = R.NRESTABELEC
                            AND R.DTVENDA BETWEEN TO_DATE(:DTVENDAINI, 'DD/MM/YYYY') AND TO_DATE(:DTVENDAFIN, 'DD/MM/YYYY')
                            AND ((INSTR (:NRESTABELEC, E.NRESTABELEC) <> 0) OR ('T' = :TNRESTABELEC))
                            AND ((INSTR (:NRADQUIRENTE, A.NRADQUIRENTE) <> 0) OR ('T' = :TNRADQUIRENTE))
                            AND ((INSTR (:NRPRODUTOADQ, P.NRPRODUTOADQ) <> 0) OR ('T' = :TNRPRODUTOADQ))
                            AND ((INSTR (:NRBANDEIRAVAN, B.NRBANDEIRAVAN) <> 0) OR ('T' = :TNRBANDEIRAVAN))
                            AND ((INSTR (   R.DTVENDA || '_' || 
                                            E.NMESTABELEC || '_' || 
                                            A.NMADQUIRENTE || '_' || 
                                            R.CDNSU, :ALL_FIELDS) <> 0) OR ('T' = :TALL_FIELDS))
                          ) PREV
                    WHERE PAGO.NRPARCELA = PREV.NRPARCELA
                     AND PAGO.CDNSU = PREV.CDNSU
                     AND PAGO.DTVENDA = PREV.DTVENDA
                     AND PAGO.NRAUTORIZACAO = PREV.NRAUTORIZACAO
                     AND PAGO.NRESTABELEC = PREV.NRESTABELEC
                    ORDER BY 2";                
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}